import type { CSSProperties } from 'vue'
import type { EdgeInsets } from '../types'
import { isSymmetric } from './is'
import { unit } from './unit'

export function insets(name: string, i: EdgeInsets | undefined): CSSProperties | undefined {
  if (i == null)
    return undefined

  if (typeof i === 'number')
    return { [name]: `${i}px` }

  if (typeof i === 'string')
    return { [name]: i }

  if (isSymmetric(i)) {
    return {
      [name]: [unit(i.vertical), unit(i.horizontal)].join(' '),
    }
  }
  return {
    [`${name}Top`]: unit(i.top),
    [`${name}Bottom`]: unit(i.bottom),
    [`${name}Left`]: unit(i.left),
    [`${name}Right`]: unit(i.right),
  }
}
