import type { BorderSide, Corners, Symmetric } from '../types'

export function isSymmetric(a: any): a is Symmetric<any> {
  return a != null
    && !Array.isArray(a)
    && typeof a === 'object'
    && ('vertical' in a || 'horizontal' in a)
}

export function isBorderSide(a: any): a is BorderSide {
  return a != null
    && !Array.isArray(a)
    && typeof a === 'object'
    && ('color' in a || 'style' in a || 'width' in a)
}

export function isCorners(a: any): a is Corners<any> {
  return a != null
    && !Array.isArray(a)
    && typeof a === 'object'
    && ('topLeft' in a
    || 'topRight' in a
    || 'bottomLeft' in a
    || 'bottomRight' in a)
}
