function find(obj: any, keys: string[]) {
  if (!keys.length)
    return obj

  if (obj == null || typeof obj !== 'object')
    return undefined

  const key = keys.shift()!
  if (!Array.isArray(obj))
    return find(obj[key], keys)

  const index = Number.parseInt(key)
  if (Number.isNaN(index))
    return undefined

  return find(obj[index], keys)
}

export function valueOf(obj: any, key: string) {
  if (!key)
    return undefined
  return find(obj, key.split('.'))
}
