import type { CSSProperties } from 'vue'
import type { Axis, Theme } from '../types'
import { unit } from './unit'

export function size(
  axis: Axis | undefined,
  theme: Theme | undefined,
): CSSProperties {
  const width = unit(theme?.width)
  const height = unit(theme?.height)
  return {
    width,
    height,
    flexBasis: theme?.basis ?? (axis === 'x' ? width : axis === 'y' ? height : undefined),
    flexGrow: theme?.grow != null ? `${theme.grow}` : undefined,
    flexShrink: theme?.shrink != null ? `${theme.shrink}` : undefined,
  }
}
